
const utils = require('./utils')
const config = require('./config') // 基本配置的参数
const HtmlWebpackPlugin = require('html-webpack-plugin')
const merge = require('webpack-merge')
const path = require('path')
let baseWebpackConfig = require('./webpack.config')

let devWebpackConfig = merge(baseWebpackConfig, {
  mode: 'production',
  entry: './src/main.js',
  output: {
    path: utils.resolve('dist-demo'),
    publicPath: '.', // 注意这个路径
    filename: 'js/[name].[id].js'
  },
  performance: {
    maxEntrypointSize: 2000 * 1024, // 入口文件超过 500KB 进行警告提示
    maxAssetSize: 2000 * 1024 // 资源文件超过 500KB 进行警告提示
  },
  module: {
    // 对一些独立的css文件以及它的预处理文件做一个编译
    rules: utils.styleLoaders({ sourceMap: config.dev.cssSourceMap, usePostCSS: true })
  },
  plugins: [
    new HtmlWebpackPlugin({
      filename: 'index.html',
      template: 'index.html',
      inject: true
    })
  ]
})

module.exports = devWebpackConfig