/*
 * @Author: SHEN
 * @Date: 2019-03-21 11:51:58
 * @Last Modified by: SHEN
 * @Last Modified time: 2020-04-09 10:16:32
 */

import SAnimScroll from './packages/SAnimScroll/index.js'
import SBadge from './packages/SBadge/index.js'
import SButton from './packages/SButton/index.js'
import SCell from './packages/SCell/index.js'
import SCheckbox from './packages/SCheckbox/index.js'
import SCellSwipe from './packages/SCellSwipe/index.js'
import SDropMenu from './packages/SDropMenu/index.js'
import SDockMenu from './packages/SDockMenu/index.js'
import SInput from './packages/SInput/index.js'
import SInfiniteScroll from './packages/SInfiniteScroll/index.js'
import SLoadmore from './packages/SLoadmore/index.js'
import SList from './packages/SList/index.js'
import SLabelText from './packages/SLabelText/index.js'
import SModal from './packages/SModal/index.js'
import SMessageBox from './packages/SMessageBox/index.js'
import SNavBar from './packages/SNavBar/index.js'
import SRadio from './packages/SRadio/index.js'
import SSpinner from './packages/SSpinner/index.js'
import { SSteps, SStepItem } from './packages/SSteps/index.js'
import SSideMenu from './packages/SSideMenu/index.js'
// import SScrollMaintain from './packages/SScrollMaintain/index.js'
import SScrollMaintain from './packages/scroll-maintain'
import SToast from './packages/SToast/index.js'
import STabbar from './packages/STabbar/index.js'
import SSwitch from './packages/SSwitch/index.js'
import { SSwiperItem, SSwiper } from './packages/SSwipe2/index.js'
import STag from './packages/STag/index.js'

const components = [
  SBadge,
  SButton,
  SCell,
  SCheckbox,
  SCellSwipe,
  SDropMenu,
  SDockMenu,
  SInput,
  SLoadmore,
  SList,
  SLabelText,
  SModal,
  SNavBar,
  SRadio,
  SSpinner,
  SSteps,
  SStepItem,
  SSideMenu,
  STabbar,
  SSwitch,
  SSwiper,
  SSwiperItem,
  STag
]

const install = function(Vue, opts = {}) {
  if (install.installed) return
  components.map(component => {
    Vue.component(component.name, component)
  })
  Vue.use(SAnimScroll)
  Vue.use(SInfiniteScroll)
  Vue.use(SScrollMaintain)

  Vue.$messagebox = Vue.prototype.$messagebox = SMessageBox
  Vue.$toast = Vue.prototype.$toast = SToast
}

/* 支持使用标签的方式引入 */
if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

// export default {}
// 如果是要使用 ss_vue_ui.min.js 引入，则这里需要修改为 export default {...}
// export {} 则需要 import * as SSVueUI from 'ss_vue_ui'
export default {
  install,
  SAnimScroll,
  SBadge,
  SButton,
  SCell,
  SCheckbox,
  SCellSwipe,
  SDropMenu,
  SDockMenu,
  SInput,
  SInfiniteScroll,
  SLoadmore,
  SList,
  SLabelText,
  SModal,
  SMessageBox,
  SNavBar,
  SRadio,
  SSpinner,
  SSteps,
  SStepItem,
  SSideMenu,
  SScrollMaintain,
  SToast,
  STabbar,
  SSwitch,
  SSwiper,
  SSwiperItem,
  STag
}
