import Badge from './badge.vue'
import { getChildrenByAttribute } from '@utils/dom'

function createBadge(Vue) {
  const Comp = Vue.extend(Badge)
  const obj = new Comp({
    el: document.createElement('div')
  })
  return obj
}

const plugin = (Vue) => {
  return Vue.directive('badge', {
    bind: function (el, binding, vnode, oldVnode) {
      if (!el.style.position) {
        el.style.position = 'relative'
      }
      const obj = createBadge(Vue)
      obj.value = binding.value
      el.appendChild(obj.$el)
    },
    inserted: function (el) {
    },
    update: function (el, binding, vnode) {
      const badges = getChildrenByAttribute(el, 'badge')
      for (const badge of badges) {
        el.removeChild(badge)
      }
      const obj = createBadge(Vue)
      obj.value = binding.value
      el.appendChild(obj.$el)
    },
    unbind(el) {
    }
  })
}

export default plugin
