import Vue from 'vue'
import msgboxVue from './message-box.vue'

var MessageBoxConstructor = Vue.extend(msgboxVue)

let instance = null
var showMsg = (options) => {
  instance = new MessageBoxConstructor({
    el: document.createElement('div')
  })
  for (var prop in options) {
    if (options.hasOwnProperty(prop)) {
      instance[prop] = options[prop]
    }
  }
  document.body.appendChild(instance.$el)

  Vue.nextTick(() => {
    instance.value = true
  })
}

var MessageBox = function(options) {
  showMsg(options)
}

MessageBox.alert = function(options) {
  return MessageBox({
    title: options.title,
    message: options.message,
    showCancel: options.showCancel,
    tapMaskHide: options.tapMaskHide,
    actionCallback: options.actionCallback,
    appearCallback: options.appearCallback,
    $type: 'alert'
  })
}

MessageBox.close = function() {
  instance && (instance.value = false)
}

export default MessageBox
export { MessageBox }
