import Vue from 'vue'
import Toast from './toast.vue'

/**
 * 需要优化：
 * 1. 多个 toast 显示问题
 */
const ToastConstructor = Vue.extend(Toast)

let instance = null

const getAnInstance = () => {
  const obj = new ToastConstructor({
    el: document.createElement('div')
  })
  return obj
}

const removeDom = event => {
  // 移除事件监听
  instance.$el.removeEventListener('transitionend', removeDom)
  document.body.removeChild(instance.$el)
  instance = null
}

ToastConstructor.prototype.close = function() {
  clearTimeout(this.timer)
  this.visible = false
  this.$el.addEventListener('transitionend', removeDom)
  this.closed = true
}

const SToast = (options = {}) => {
  // 显示时间
  const duration = options.duration || 0

  // 从body中移除已存在的 toast
  if (instance) {
    clearTimeout(instance.timer)
    if (instance.$el.parentNode) {
      instance.$el.parentNode.removeChild(instance.$el)
    }
  }
  instance = getAnInstance()
  instance.closed = false
  clearTimeout(instance.timer)

  /** 赋值 */
  instance.message = typeof options === 'string' ? options : options.message
  instance.position = options.position || 'middle'
  instance.className = options.className || ''
  instance.iconClass = options.iconClass || ''
  instance.tapHide = options.tapHide || false
  instance.showMask = options.showMask || false
  instance.showIndicator = options.showIndicator || false
  instance.textAlign = options.textAlign || 'vertical'

  // 添加到 body 上
  document.body.appendChild(instance.$el)

  Vue.nextTick(function() {
    instance.visible = true
    duration && (instance.timer = setTimeout(() => {
      if (instance && instance.closed) {
        return
      }
      instance && instance.close()
    }, duration))
  })
  return instance
}

export default SToast
