/**
 * Created by hs on 17/4/17.
 */

var plugin = function (Vue) {
  function updatePosition(el) {
    var i, len, pos, target, targets
    targets = el.querySelectorAll('[data-vue-scroll-maintain]')
    if (targets.length > 0) {
      for (i = 0, len = targets.length; i < len; i++) {
        target = targets[i]
        pos = target.getAttribute('data-vue-scroll-maintain').split('-')
        target.scrollLeft = pos[0]
        target.scrollTop = pos[1]
      }
    } else {
      if (el.hasAttribute('data-vue-scroll-maintain')) {
        pos = el.getAttribute('data-vue-scroll-maintain').split('-')
        el.scrollLeft = pos[0]
        el.scrollTop = pos[1]
      }
    }
  }
  return Vue.directive('scroll-maintain', {
    bind: function (el, binding, vnode) {
      el.addEventListener('scroll', function (event) {
        var val = event.target.scrollLeft + '-' + event.target.scrollTop
        event.target.setAttribute('data-vue-scroll-maintain', val)
      })
    },
    inserted: function (el) {
      updatePosition(el)
    },
    update: function (el) {
      updatePosition(el)
    }
  })
}

// module.exports = plugin
export default plugin
