import Vue from 'vue'
import dialog from './feedback-dialog.vue'

var DialogConstructor = Vue.extend(dialog)

let instance = null
var showMsg = (options) => {
  instance = new DialogConstructor({
    el: document.createElement('div')
  })
  for (var prop in options) {
    if (options.hasOwnProperty(prop)) {
      instance[prop] = options[prop]
    }
  }
  document.body.appendChild(instance.$el)

  Vue.nextTick(() => {
    instance.value = true
  })
}

var FeedbackDialog = function(options) {
  showMsg(options)
}

FeedbackDialog.alert = function(options) {
  return FeedbackDialog({
    tapMaskHide: options.tapMaskHide,
    callback: options.callback,
    type: options.type,
    $type: 'alert'
  })
}

FeedbackDialog.close = function() {
  instance && (instance.value = false)
}

export default FeedbackDialog
export { FeedbackDialog }
